import { useEffect, useRef, useState } from 'react';
import { isClient } from './util';
var useWindowScroll = function () {
    var frame = useRef(0);
    var _a = useState({
        x: isClient ? window.scrollX : 0,
        y: isClient ? window.scrollY : 0,
    }), state = _a[0], setState = _a[1];
    useEffect(function () {
        var handler = function () {
            cancelAnimationFrame(frame.current);
            frame.current = requestAnimationFrame(function () {
                setState({
                    x: window.scrollX,
                    y: window.scrollY,
                });
            });
        };
        window.addEventListener('scroll', handler, {
            capture: false,
            passive: true,
        });
        return function () {
            cancelAnimationFrame(frame.current);
            window.removeEventListener('scroll', handler);
        };
    }, []);
    return state;
};
export default useWindowScroll;
