"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var useRefMounted_1 = require("./useRefMounted");
function useAsyncFn(fn, deps, initialState) {
    if (deps === void 0) { deps = []; }
    if (initialState === void 0) { initialState = { loading: false }; }
    var _a = react_1.useState(initialState), state = _a[0], set = _a[1];
    var mounted = useRefMounted_1.default();
    var callback = react_1.useCallback(function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        set({ loading: true });
        return fn.apply(void 0, args).then(function (value) {
            if (mounted.current) {
                set({ value: value, loading: false });
            }
            return value;
        }, function (error) {
            if (mounted.current) {
                set({ error: error, loading: false });
            }
            return error;
        });
    }, deps);
    return [state, callback];
}
exports.default = useAsyncFn;
