"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var useList = function (initialList) {
    if (initialList === void 0) { initialList = []; }
    var _a = react_1.useState(initialList), list = _a[0], set = _a[1];
    return [
        list,
        {
            set: set,
            clear: function () { return set([]); },
            updateAt: function (index, entry) {
                return set(function (currentList) { return currentList.slice(0, index).concat([entry], currentList.slice(index + 1)); });
            },
            remove: function (index) { return set(function (currentList) { return currentList.slice(0, index).concat(currentList.slice(index + 1)); }); },
            push: function (entry) { return set(function (currentList) { return currentList.concat([entry]); }); },
            filter: function (fn) { return set(function (currentList) { return currentList.filter(fn); }); },
            sort: function (fn) { return set(function (currentList) { return currentList.slice().sort(fn); }); },
        },
    ];
};
exports.default = useList;
